package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

	import flash.geom.Point;


	public class AI extends Player
	{
		public const IsHuman:Boolean=false;

		public function AI(Jeu:Game,Joueur:int)
		{
			this.Jeu = Jeu;
			this.Terrain = Jeu.Terrain;
			this.Joueur=Joueur;
		}

		public function Jouer():void
		{
			Tour_Termine=false;
			var Aretes_Ponderees:Array=this.getPonderedEdges();
			var Nb:int=Aretes_Ponderees.length;
			var BestEdge:Arc;
			var BestEdgesCoeff:Number=-1;
			var CurrCoeff:Number;

			for(var i:int=0;i<Nb;i++)
			{
				CurrCoeff=Aretes_Ponderees[i];
				if(BestEdgesCoeff<=CurrCoeff)
				{
					BestEdge=this.Jeu.getEdgeFromId(i);
					BestEdgesCoeff=CurrCoeff;
				}
				if(CurrCoeff!=0)
					this.Jeu.getEdgeFromId(i).Caption=(Math.round(CurrCoeff*100)/100).toString();
			}
			JouerArete(BestEdge);
		}

		//Fonctions prives

		private function getPonderedEdges():Array
		{//Cette fonction renvoie la liste des artes tries par ordre d'importance...selon un pseudo-pathfinding.
			var All_Possible_Path:Array=new Array();
			var ForbiddenEdge:DictionaryPlus=new DictionaryPlus();
// 			for each(var Node:Noeud in this.Terrain.All_Noeuds)
// 			{
// 				if(Node.Liens.length==2 && Node.Liens[0]!=Node.Liens[1] && !Node.Liens[0].PlayedByShort && !Node.Liens[1].PlayedByShort)
// 				{//Si un noeud n'a que deux liens, et que ces deux liens ne pointent pas au mme endroit : pas besoin de chercher, ils sont inutiles (amnenent un statu quo) !
// 					ForbiddenEdge[Node.Liens[0]]=true;
// 					ForbiddenEdge[Node.Liens[1]]=true;
// 					Node.Liens[0].AddFocus(5);
// 					Node.Liens[1].AddFocus(5);
// 				}
// 			}

			function PathFind(Node:Noeud,Path:DictionaryPlus,Node_Liste:DictionaryPlus):void
			{
				//Si le noeud examin est le noeud final, on a un nouveau chemin : l'enregistrer en mmoire.
				if(Node==Terrain.EndNode)
					All_Possible_Path.push(Path);
				else
				{
	// 				Puis on regarde chaque arete du noeud et on teste rcursivement.
					for each(var Arete:Arc in Node.Liens)
					{
						var AutreExtremite:Noeud;
						if(Arete.Extremites[0]==Node)
							AutreExtremite=Arete.Extremites[1];
						else
							AutreExtremite=Arete.Extremites[0];

						if(!Path.Contains(Arete) && !Node_Liste.Contains(AutreExtremite) && !ForbiddenEdge.Contains(Arete))
						{
							var CopiePath:DictionaryPlus=Path.Clone();
							CopiePath[Arete]=true;
							var CopieNode:DictionaryPlus=Node_Liste.Clone();
							CopieNode[AutreExtremite]=true;
							PathFind(AutreExtremite,CopiePath,CopieNode)
						}
					}
				}
			}
			var Node_Liste:DictionaryPlus=new DictionaryPlus();
			Node_Liste[Terrain.StartNode]=true;
			PathFind(Terrain.StartNode,new DictionaryPlus(),Node_Liste);

			//A ce point, le tableau All_Possible_Path est plein et contient l'ensemble des chemins que l'on peut emprunter pour se rendre du dpart  l'arrive.

			function SizeOf(Item:DictionaryPlus):Number
			{//Renvoie le nombre minimal d'artes  allumer pour terminer le chemin :
				var Jouees:int=0;
				var Total:int=0;
				for(var Arete:* in Item)
				{
					if(Arete.PlayedByShort)
						Jouees++;
					Total++;
				}
				var DeltaS:int=Total-Jouees;
				if(DeltaS>1)
					return DeltaS;
				else
					return 0.001;
			}

			//On initialise la rponse :
			var Poids:Array=new Array();
			var Taille:int=this.Terrain.initialAll_Lienslength;
			for(var i:int=0;i<Taille;i++)
				Poids[i]=0;

			//On va maintenant compter combien de fois chaque arete est prsente :
			for each(var Path:DictionaryPlus in All_Possible_Path)
			{
// 				Taille=SizeOf(Path);
				Taille=Math.pow(SizeOf(Path),2);
				for(var Arete:* in Path)
				{
					if(!Arete.PlayedByShort)
						Poids[Arete.ID] +=1/Taille;
				}
			}
			return Poids;
		}
	}
}